diff --git a/app/controllers/hosts_controller.rb b/app/controllers/hosts_controller.rb
index 349c048bf..f9a80c1b3 100644
--- a/app/controllers/hosts_controller.rb
+++ b/app/controllers/hosts_controller.rb
@@ -8,26 +8,30 @@ class HostsController < ApplicationController
   SEARCHABLE_ACTIONS= %w[index active errors out_of_sync pending disabled ]
   AJAX_REQUESTS=%w{compute_resource_selected hostgroup_or_environment_selected current_parameters puppetclass_parameters process_hostgroup process_taxonomy}
   BOOT_DEVICES={ :disk => N_('Disk'), :cdrom => N_('CDROM'), :pxe => N_('PXE'), :bios => N_('BIOS') }
+  MULTIPLE_ACTIONS = %w(multiple_parameters update_multiple_parameters  select_multiple_hostgroup
+                        update_multiple_hostgroup select_multiple_environment update_multiple_environment
+                        multiple_destroy submit_multiple_destroy multiple_build
+                        submit_multiple_build multiple_disable submit_multiple_disable
+                        multiple_enable submit_multiple_enable multiple_puppetrun
+                        update_multiple_puppetrun multiple_disassociate update_multiple_disassociate)
 
   add_puppetmaster_filters PUPPETMASTER_ACTIONS
   before_filter :ajax_request, :only => AJAX_REQUESTS
-  before_filter :find_multiple, :only => [:update_multiple_parameters, :multiple_build,
-    :select_multiple_hostgroup, :select_multiple_environment, :multiple_parameters, :multiple_destroy,
-    :multiple_enable, :multiple_disable, :submit_multiple_disable, :submit_multiple_enable, :update_multiple_hostgroup,
-    :update_multiple_environment, :submit_multiple_build, :submit_multiple_destroy, :update_multiple_puppetrun,
-    :multiple_puppetrun, :multiple_disassociate, :update_multiple_disassociate]
-  before_filter :find_by_name, :only => %w[show edit update destroy puppetrun setBuild cancelBuild
-    storeconfig_klasses clone pxe_config toggle_manage power console bmc ipmi_boot disassociate]
+  before_filter :find_by_name, :only => [:show, :clone, :edit, :update, :destroy, :puppetrun,
+                                         :setBuild, :cancelBuild, :power, :bmc, :ipmi_boot,
+                                         :console, :toggle_manage, :pxe_config,
+                                         :storeconfig_klasses, :disassociate]
   before_filter :taxonomy_scope, :only => [:new, :edit] + AJAX_REQUESTS
   before_filter :set_host_type, :only => [:update]
+  before_filter :find_multiple, :only => MULTIPLE_ACTIONS
   helper :hosts, :reports
 
   def index (title = nil)
     begin
-      search = Host.my_hosts.search_for(params[:search],:order => params[:order])
+      search = resource_base.search_for(params[:search], :order => params[:order])
     rescue => e
       error e.to_s
-      search = Host.my_hosts.search_for ''
+      search = resource_base.search_for ''
     end
     respond_to do |format|
       format.html do
@@ -35,6 +39,7 @@ class HostsController < ApplicationController
         # SQL optimizations queries
         @last_reports = Report.where(:host_id => @hosts.map(&:id)).group(:host_id).maximum(:id)
         # rendering index page for non index page requests (out of sync hosts etc)
+        @hostgroup_authorizer = Authorizer.new(User.current, :collection => @hosts.map(&:hostgroup_id).compact.uniq)
         render :index if title and (@title = title)
       end
       format.yaml do
@@ -133,7 +138,7 @@ class HostsController < ApplicationController
     return not_found unless (params[:host] && (id=params[:host][:compute_resource_id]))
     Taxonomy.as_taxonomy @organization, @location do
       compute_profile_id = params[:host][:compute_profile_id] || Hostgroup.find_by_id(params[:host][:hostgroup_id]).try(:compute_profile_id)
-      compute_resource = ComputeResource.find(id)
+      compute_resource = ComputeResource.authorized(:view_compute_resources).find_by_id(id)
       render :partial => "compute", :locals => { :compute_resource => compute_resource,
                                                  :vm_attrs         => compute_resource.compute_profile_attributes_for(compute_profile_id) }
     end
@@ -168,8 +173,8 @@ class HostsController < ApplicationController
 
   def externalNodes
     certname = params[:name]
-    @host ||= Host.find_by_certname certname
-    @host ||= Host.find_by_name certname
+    @host ||= resource_base.find_by_certname certname
+    @host ||= resource_base.find_by_name certname
     not_found and return unless @host
 
     begin
@@ -475,7 +480,7 @@ class HostsController < ApplicationController
     @compute_profile = @hostgroup.compute_profile
 
     @host = if params[:host][:id]
-      host = Host::Base.find(params[:host][:id])
+      host = Host::Base.authorized(:view_hosts, Host).find(params[:host][:id])
       host = host.becomes Host::Managed
       host.attributes = params[:host]
       host
@@ -528,8 +533,41 @@ class HostsController < ApplicationController
 
   private
 
+  def resource_base
+    @resource_base ||= Host.authorized(current_permission, Host)
+  end
+
+  def action_permission
+    case params[:action]
+      when 'clone', 'externalNodes', 'bmc', 'pxe_config', 'storeconfig_klasses',
+          'active', 'errors', 'out_of_sync', 'pending', 'disabled'
+        :view
+      when 'puppetrun', 'multiple_puppetrun', 'update_multiple_puppetrun'
+        :puppetrun
+      when 'setBuild', 'cancelBuild', 'multiple_build', 'submit_multiple_build'
+        :build
+      when 'power'
+        :power
+      when 'ipmi_boot'
+        :ipmi_boot
+      when 'console'
+        :console
+      when 'toggle_manage', 'multiple_parameters', 'update_multiple_parameters',
+          'select_multiple_hostgroup', 'update_multiple_hostgroup', 'select_multiple_environment',
+          'update_multiple_environment', 'multiple_disable', 'submit_multiple_disable',
+          'multiple_enable', 'submit_multiple_enable',
+          'update_multiple_organization', 'select_multiple_organization',
+          'update_multiple_location', 'select_multiple_location'
+        :edit
+      when 'multiple_destroy', 'submit_multiple_destroy'
+        :destroy
+      else
+        super
+    end
+  end
+
   def refresh_host
-    @host = Host::Base.find_by_id(params['host_id'])
+    @host = Host::Base.authorized(:view_hosts, Host).find_by_id(params['host_id'])
     if @host
       unless @host.kind_of?(Host::Managed)
         @host      = @host.becomes(Host::Managed)
@@ -585,13 +623,14 @@ class HostsController < ApplicationController
     # determine if we are searching for a numerical id or plain name
 
     if id =~ /^\d+$/
-      @host = Host::Base.my_hosts.find_by_id id.to_i
+      @host = resource_base.find_by_id id.to_i
     else
-      @host = Host::Base.my_hosts.find_by_name id.downcase
-      @host ||= Host::Base.my_hosts.find_by_mac params[:host][:mac] if params[:host] && params[:host][:mac]
+      @host = resource_base.find_by_name id.downcase
+      @host ||= resource_base.find_by_mac params[:host][:mac] if params[:host] && params[:host][:mac]
     end
 
-    not_found and return false unless @host
+    not_found and return(false) unless @host
+    @host
   end
 
   def load_vars_for_ajax
@@ -611,7 +650,7 @@ class HostsController < ApplicationController
   def find_multiple
   # Lets search by name or id and make sure one of them exists first
     if params[:host_names].present? or params[:host_ids].present?
-      @hosts = Host::Base.where("id IN (?) or name IN (?)", params[:host_ids], params[:host_names] )
+      @hosts = resource_base.where("id IN (?) or name IN (?)", params[:host_ids], params[:host_names] )
       if @hosts.empty?
         error _('No hosts were found with that id or name')
         redirect_to(hosts_path) and return false
@@ -621,9 +660,12 @@ class HostsController < ApplicationController
       redirect_to(hosts_path) and return false
     end
 
-    rescue => e
-      error _("Something went wrong while selecting hosts - %s") % (e)
-      redirect_to hosts_path
+    return @hosts
+  rescue => e
+    error _("Something went wrong while selecting hosts - %s") % (e)
+    logger.debug e.message
+    logger.debug e.backtrace.join("\n")
+    redirect_to hosts_path and return false
   end
 
   def toggle_hostmode mode=true
diff --git a/app/controllers/images_controller.rb b/app/controllers/images_controller.rb
index 258a10605..248eccd92 100644
--- a/app/controllers/images_controller.rb
+++ b/app/controllers/images_controller.rb
@@ -1,10 +1,10 @@
 class ImagesController < ApplicationController
   before_filter :find_compute_resource
-  before_filter :find_by_name, :except => [:index, :new, :create]
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
 
   def index
     # Listing images in /hosts/new consumes this method as JSON
-    values = @compute_resource.images.search_for(params[:search], :order => params[:order])
+    values = resource_base.where(:compute_resource_id => @compute_resource.id).search_for(params[:search], :order => params[:order])
     respond_to do |format|
       format.html { @images = values.paginate :page => params[:page] }
       format.json { render :json => values }
@@ -46,7 +46,7 @@ class ImagesController < ApplicationController
   private
 
   def find_compute_resource
-    @compute_resource = ComputeResource.find(params[:compute_resource_id])
+    @compute_resource = ComputeResource.authorized(:view_compute_resources).find(params[:compute_resource_id])
   end
 
 end
diff --git a/app/controllers/lookup_keys_controller.rb b/app/controllers/lookup_keys_controller.rb
index 39cef7812..4a26e3e7c 100644
--- a/app/controllers/lookup_keys_controller.rb
+++ b/app/controllers/lookup_keys_controller.rb
@@ -1,10 +1,11 @@
 class LookupKeysController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
-  before_filter :find_by_key, :except => :index
   before_filter :setup_search_options, :only => :index
+  before_filter :find_by_key, :only => [:edit, :update, :destroy], :if => Proc.new { params[:id] }
 
   def index
-    @lookup_keys = LookupKey.search_for(params[:search], :order => params[:order]).includes(:puppetclass).paginate(:page => params[:page])
+    @lookup_keys = resource_base.search_for(params[:search], :order => params[:order]).includes(:param_classes, :puppetclass).paginate(:page => params[:page])
+    @puppetclass_authorizer = Authorizer.new(User.current, :collection => @lookup_keys.map(&:puppetclass_id).compact.uniq)
   end
 
   def edit
@@ -27,10 +28,14 @@ class LookupKeysController < ApplicationController
   end
 
   private
+
   def find_by_key
-    if params[:id]
-      @lookup_key = LookupKey.find(params[:id])
-      not_found and return if @lookup_key.blank?
-    end
+    @lookup_key = resource_base.find(params[:id])
+    not_found and return if @lookup_key.blank?
+    @lookup_key
+  end
+
+  def controller_permission
+    'external_variables'
   end
 end
diff --git a/app/controllers/media_controller.rb b/app/controllers/media_controller.rb
index abd65fd76..76d13b229 100644
--- a/app/controllers/media_controller.rb
+++ b/app/controllers/media_controller.rb
@@ -1,9 +1,9 @@
 class MediaController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
-  before_filter :find_medium, :only => %w{edit update destroy}
+  before_filter :find_by_name, :only => %w{edit update destroy}
 
   def index
-    @media = Medium.includes(:operatingsystems).search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @media = resource_base.includes(:operatingsystems).search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
   end
 
   def new
@@ -38,9 +38,4 @@ class MediaController < ApplicationController
     end
   end
 
-  private
-  def find_medium
-    @medium = Medium.find(params[:id])
-  end
-
 end
diff --git a/app/controllers/models_controller.rb b/app/controllers/models_controller.rb
index 23b00226c..ef7de838b 100644
--- a/app/controllers/models_controller.rb
+++ b/app/controllers/models_controller.rb
@@ -1,8 +1,9 @@
 class ModelsController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
 
   def index
-    @models  = Model.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @models       = resource_base.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
     @host_counter = Host.group(:model_id).where(:model_id => @models.select(&:id)).count
   end
 
@@ -20,11 +21,9 @@ class ModelsController < ApplicationController
   end
 
   def edit
-    @model = Model.find(params[:id])
   end
 
   def update
-    @model = Model.find(params[:id])
     if @model.update_attributes(params[:model])
       process_success
     else
@@ -33,11 +32,11 @@ class ModelsController < ApplicationController
   end
 
   def destroy
-    @model = Model.find(params[:id])
     if @model.destroy
       process_success
     else
       process_error
     end
   end
+
 end
diff --git a/app/controllers/operatingsystems_controller.rb b/app/controllers/operatingsystems_controller.rb
index 518725d06..c1ad640f0 100644
--- a/app/controllers/operatingsystems_controller.rb
+++ b/app/controllers/operatingsystems_controller.rb
@@ -1,9 +1,9 @@
 class OperatingsystemsController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
-  before_filter :find_os, :only => %w{edit update destroy bootfiles}
+  before_filter :find_by_name, :only => %w{edit update destroy}
 
   def index
-    @operatingsystems = Operatingsystem.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @operatingsystems = resource_base.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
     @host_counter     = Host.group(:operatingsystem_id).where(:operatingsystem_id => @operatingsystems.collect(&:id)).count
   end
 
@@ -44,10 +44,4 @@ class OperatingsystemsController < ApplicationController
       process_error
     end
   end
-
-  private
-  def find_os
-    @operatingsystem = Operatingsystem.find(params[:id])
-  end
-
 end
diff --git a/app/controllers/permissions_controller.rb b/app/controllers/permissions_controller.rb
new file mode 100644
index 000000000..702c88496
--- /dev/null
+++ b/app/controllers/permissions_controller.rb
@@ -0,0 +1,18 @@
+class PermissionsController < ApplicationController
+  include FiltersHelper
+  respond_to :js
+
+  def index
+    type = params[:resource_type].blank? ? nil : params[:resource_type]
+    @permissions = Permission.find_all_by_resource_type(type)
+    @search_path = search_path(type)
+    @granular = granular?(type)
+  end
+
+  private
+
+  def granular?(type)
+    Filter.new(:resource_type => type).granular?
+  end
+
+end
diff --git a/app/controllers/ptables_controller.rb b/app/controllers/ptables_controller.rb
index 3b507818f..ab34c65a3 100644
--- a/app/controllers/ptables_controller.rb
+++ b/app/controllers/ptables_controller.rb
@@ -1,9 +1,10 @@
 class PtablesController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
-  before_filter :find_ptable, :only => %w{edit update destroy}
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
 
   def index
-    @ptables = Ptable.includes(:operatingsystems).search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @ptables = resource_base.includes(:operatingsystems).
+      search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
   end
 
   def new
@@ -38,9 +39,4 @@ class PtablesController < ApplicationController
     end
   end
 
-  private
-  def find_ptable
-    @ptable = Ptable.find(params[:id])
-  end
-
 end
diff --git a/app/controllers/puppetca_controller.rb b/app/controllers/puppetca_controller.rb
index 7e0dbf34e..49af71fff 100644
--- a/app/controllers/puppetca_controller.rb
+++ b/app/controllers/puppetca_controller.rb
@@ -1,10 +1,9 @@
 class PuppetcaController < ApplicationController
-  before_filter :find_proxy
 
   def index
+    @proxy = find_proxy
     # expire cache if forced
     Rails.cache.delete("ca_#{@proxy.id}") if params[:expire_cache] == "true"
-
     begin
       certs = if params[:state].blank?
                 SmartProxies::PuppetCA.find_by_state(@proxy, "valid") + SmartProxies::PuppetCA.find_by_state(@proxy, "pending")
@@ -26,6 +25,7 @@ class PuppetcaController < ApplicationController
   end
 
   def update
+    @proxy = find_proxy(:edit_smart_proxies_puppetca)
     cert = SmartProxies::PuppetCA.find(@proxy, params[:id])
     if cert.sign
       process_success({ :success_redirect => smart_proxy_puppetca_index_path(@proxy, :state => params[:state]), :object_name => cert.to_s })
@@ -37,6 +37,7 @@ class PuppetcaController < ApplicationController
   end
 
   def destroy
+    @proxy = find_proxy(:destroy_smart_proxies_puppetca)
     cert = SmartProxies::PuppetCA.find(@proxy, params[:id])
     if cert.destroy
       process_success({ :success_redirect => smart_proxy_puppetca_index_path(@proxy, :state => params[:state]), :object_name => cert.to_s })
@@ -47,8 +48,8 @@ class PuppetcaController < ApplicationController
 
   private
 
-  def find_proxy
-    @proxy = SmartProxy.find(params[:smart_proxy_id])
+  def find_proxy(permission = :view_smart_proxies_puppetca)
+    SmartProxy.authorized(permission).find(params[:smart_proxy_id])
   end
 
 end
diff --git a/app/controllers/puppetclasses_controller.rb b/app/controllers/puppetclasses_controller.rb
index f276b74dd..63fc2727d 100644
--- a/app/controllers/puppetclasses_controller.rb
+++ b/app/controllers/puppetclasses_controller.rb
@@ -1,15 +1,16 @@
 class PuppetclassesController < ApplicationController
   include Foreman::Controller::Environments
   include Foreman::Controller::AutoCompleteSearch
-  before_filter :find_by_name, :only => [:edit, :update, :destroy, :assign]
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
   before_filter :setup_search_options, :only => :index
   before_filter :reset_redirect_to_url, :only => :index
   before_filter :store_redirect_to_url, :only => :edit
 
   def index
-    @puppetclasses = Puppetclass.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    @puppetclasses = resource_base.search_for(params[:search], :order => params[:order]).includes(:environments, :hostgroups).paginate(:page => params[:page])
     @host_counter = Host.group(:puppetclass_id).joins(:puppetclasses).where(:puppetclasses => {:id => @puppetclasses.collect(&:id)}).count
     @keys_counter = Puppetclass.joins(:class_params).select('distinct environment_classes.lookup_key_id').group(:name).count
+    @hostgroups_authorizer = Authorizer.new(User.current, :collection => HostgroupClass.find_all_by_puppetclass_id(@puppetclasses.map(&:id)).compact.uniq.map(&:hostgroup_id))
   end
 
   def new
@@ -96,8 +97,9 @@ class PuppetclassesController < ApplicationController
 
   def find_by_name
     not_found and return if params[:id].blank?
-    pc = Puppetclass.includes(:class_params => [:environment_classes, :environments, :lookup_values])
+    pc = resource_base.includes(:class_params => [:environment_classes, :environments, :lookup_values])
     @puppetclass = (params[:id] =~ /\A\d+\Z/) ? pc.find(params[:id]) : pc.find_by_name(params[:id])
     not_found and return unless @puppetclass
   end
+
 end
diff --git a/app/controllers/reports_controller.rb b/app/controllers/reports_controller.rb
index 922af0abc..26eb17246 100644
--- a/app/controllers/reports_controller.rb
+++ b/app/controllers/reports_controller.rb
@@ -4,24 +4,25 @@ class ReportsController < ApplicationController
   before_filter :setup_search_options, :only => :index
 
   def index
-    @reports = Report.my_reports.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page], :per_page => params[:per_page]).includes(:host)
+    report_authorized = resource_base.my_reports
+    @reports = report_authorized.search_for(params[:search], :order => params[:order]).paginate(:page => params[:page], :per_page => params[:per_page]).includes(:host)
   end
 
   def show
     # are we searching for the last report?
     if params[:id] == "last"
       conditions = { :host_id => Host.find_by_name(params[:host_id]).try(:id) } unless params[:host_id].blank?
-      params[:id] = Report.my_reports.where(conditions).maximum(:id)
+      params[:id] = resource_base.where(conditions).maximum(:id)
     end
 
     return not_found if params[:id].blank?
 
-    @report = Report.my_reports.includes(:logs => [:message, :source]).find(params[:id])
+    @report = resource_base.includes(:logs => [:message, :source]).find(params[:id])
     @offset = @report.reported_at - @report.created_at
   end
 
   def destroy
-    @report = Report.find(params[:id])
+    @report = resource_base.find(params[:id])
     if @report.destroy
       notice _("Successfully destroyed report.")
     else
diff --git a/app/controllers/roles_controller.rb b/app/controllers/roles_controller.rb
index 3b6008a6f..bbf5c5b26 100644
--- a/app/controllers/roles_controller.rb
+++ b/app/controllers/roles_controller.rb
@@ -17,7 +17,7 @@
 
 class RolesController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
-  before_filter :require_admin
+  before_filter :find_by_id, :only => [:clone, :edit, :update, :destroy]
 
   def index
     @roles = Role.search_for(params[:search], :order => params[:order]).paginate :page => params[:page]
@@ -25,11 +25,12 @@ class RolesController < ApplicationController
 
   def new
     # Prefills the form with 'default user' role permissions
-    @role        = Role.new({:permissions => Role.default_user.permissions})
+    @role = Role.new({:permissions => Role.default_user.permissions})
   end
 
   def create
-    @role = Role.new(params[:role])
+    @role = role_from_form
+
     if @role.save
       process_success
     else
@@ -37,12 +38,19 @@ class RolesController < ApplicationController
     end
   end
 
+  def clone
+    @cloned_role      = true
+    @original_role_id = @role.id
+    flash[:notice] = _("Role cloned from role %{old_name}") %
+                      { :old_name => @role.name }
+    @role = Role.new
+    render :action => :new
+  end
+
   def edit
-    @role = Role.find(params[:id])
   end
 
   def update
-    @role = Role.find(params[:id])
     if @role.update_attributes(params[:role])
       process_success
     else
@@ -51,7 +59,6 @@ class RolesController < ApplicationController
   end
 
   def destroy
-    @role = Role.find(params[:id])
     if @role.destroy
       process_success
     else
@@ -59,16 +66,32 @@ class RolesController < ApplicationController
     end
   end
 
-  def report
-    @roles = Role.all(:order => 'builtin, name')
-    @permissions = Foreman::AccessControl.permissions.select { |p| !p.public? }
-    if request.post?
-      @roles.each do |role|
-        role.permissions = params[:permissions][role.id.to_s]
-        role.save
-      end
-      notice _("All non public permissions successfully updated")
-      redirect_to roles_url
+  private
+
+  def find_by_id
+    @role = Role.find(params[:id])
+  end
+
+  def action_permission
+    case params[:action]
+      when 'clone'
+        'view'
+      else
+        super
+    end
+  end
+
+  def role_from_form
+    if params[:original_role_id].present?
+      new_role = Role.find(params[:original_role_id]).
+                   dup(:include => [:filters => :filterings])
+      new_role.name    = params[:role][:name]
+      new_role.builtin = false
+    else
+      new_role = Role.new(params[:role])
     end
+
+    new_role
   end
+
 end
diff --git a/app/controllers/smart_proxies_controller.rb b/app/controllers/smart_proxies_controller.rb
index fa81940c7..dcc8d41d1 100644
--- a/app/controllers/smart_proxies_controller.rb
+++ b/app/controllers/smart_proxies_controller.rb
@@ -1,20 +1,22 @@
 class SmartProxiesController < ApplicationController
-  before_filter :find_by_id, :only => [:edit, :update, :destroy, :ping, :refresh]
+
+  include Foreman::Controller::AutoCompleteSearch
+  before_filter :find_by_name, :only => [:edit, :update, :refresh, :ping, :destroy]
 
   def index
-    @proxies = SmartProxy.includes(:features).paginate :page => params[:page]
+    @smart_proxies = resource_base.includes(:features).paginate :page => params[:page]
   end
 
   def new
-    @proxy = SmartProxy.new
+    @smart_proxy = SmartProxy.new
   end
 
   def create
-    @proxy = SmartProxy.new(params[:smart_proxy])
-    if @proxy.save
-      process_success :object => @proxy
+    @smart_proxy = SmartProxy.new(params[:smart_proxy])
+    if @smart_proxy.save
+      process_success :object => @smart_proxy
     else
-      process_error :object => @proxy
+      process_error :object => @smart_proxy
     end
   end
 
@@ -23,38 +25,46 @@ class SmartProxiesController < ApplicationController
 
   def ping
     respond_to do |format|
-      format.json {render :json => errors_hash(@proxy.refresh)}
+      format.json {render :json => errors_hash(@smart_proxy.refresh)}
     end
   end
 
   def refresh
-    old_features = @proxy.features
-    if @proxy.refresh.blank? && @proxy.save
-      msg = @proxy.features == old_features ? _("No changes found when refreshing features from %s.") : _("Successfully refreshed features from %s.")
-      process_success :object => @proxy, :success_msg => msg % @proxy.name
+    old_features = @smart_proxy.features
+    if @smart_proxy.refresh.blank? && @smart_proxy.save
+      msg = @smart_proxy.features == old_features ? _("No changes found when refreshing features from %s.") : _("Successfully refreshed features from %s.")
+      process_success :object => @smart_proxy, :success_msg => msg % @smart_proxy.name
     else
-      process_error :object => @proxy
+      process_error :object => @smart_proxy
     end
   end
 
   def update
-    if @proxy.update_attributes(params[:smart_proxy])
-      process_success :object => @proxy
+    if @smart_proxy.update_attributes(params[:smart_proxy])
+      process_success :object => @smart_proxy
     else
-      process_error :object => @proxy
+      process_error :object => @smart_proxy
     end
   end
 
   def destroy
-    if @proxy.destroy
-      process_success :object => @proxy
+    if @smart_proxy.destroy
+      process_success :object => @smart_proxy
     else
-      process_error :object => @proxy
+      process_error :object => @smart_proxy
     end
   end
 
   private
-  def find_by_id
-    @proxy = SmartProxy.find(params[:id])
+
+  def action_permission
+    case params[:action]
+      when 'refresh'
+        :edit
+      when 'ping'
+        :view
+      else
+        super
+    end
   end
 end
diff --git a/app/controllers/statistics_controller.rb b/app/controllers/statistics_controller.rb
index 6d744c81c..294c328d4 100644
--- a/app/controllers/statistics_controller.rb
+++ b/app/controllers/statistics_controller.rb
@@ -1,18 +1,18 @@
 class StatisticsController < ApplicationController
 
   def index
-    @os_count    = Host.my_hosts.count_distribution :operatingsystem
-    @arch_count  = Host.my_hosts.count_distribution :architecture
-    @env_count   = Host.my_hosts.count_distribution :environment
-    @klass_count = Host.my_hosts.count_habtm "puppetclass"
-    @cpu_count   = FactValue.my_facts.count_each "processorcount"
-    @model_count = FactValue.my_facts.count_each "manufacturer"
-    @mem_size    = FactValue.my_facts.mem_average "memorysize"
-    @mem_free    = FactValue.my_facts.mem_average "memoryfree"
-    @swap_size   = FactValue.my_facts.mem_average "swapsize"
-    @swap_free   = FactValue.my_facts.mem_average "swapfree"
-    @mem_totsize = FactValue.my_facts.mem_sum "memorysize"
-    @mem_totfree = FactValue.my_facts.mem_sum "memoryfree"
+    @os_count    = Host.authorized(:view_hosts, Host).count_distribution :operatingsystem
+    @arch_count  = Host.authorized(:view_hosts, Host).count_distribution :architecture
+    @env_count   = Host.authorized(:view_hosts, Host).count_distribution :environment
+    @klass_count = Host.authorized(:view_hosts, Host).count_habtm "puppetclass"
+    @cpu_count   = FactValue.authorized(:view_facts).my_facts.count_each "processorcount"
+    @model_count = FactValue.authorized(:view_facts).my_facts.count_each "manufacturer"
+    @mem_size    = FactValue.authorized(:view_facts).my_facts.mem_average "memorysize"
+    @mem_free    = FactValue.authorized(:view_facts).my_facts.mem_average "memoryfree"
+    @swap_size   = FactValue.authorized(:view_facts).my_facts.mem_average "swapsize"
+    @swap_free   = FactValue.authorized(:view_facts).my_facts.mem_average "swapfree"
+    @mem_totsize = FactValue.authorized(:view_facts).my_facts.mem_sum "memorysize"
+    @mem_totfree = FactValue.authorized(:view_facts).my_facts.mem_sum "memoryfree"
     respond_to do |format|
       format.html
       format.json do
diff --git a/app/controllers/subnets_controller.rb b/app/controllers/subnets_controller.rb
index 151f09de4..6239ec4a4 100644
--- a/app/controllers/subnets_controller.rb
+++ b/app/controllers/subnets_controller.rb
@@ -1,8 +1,9 @@
 class SubnetsController < ApplicationController
   include Foreman::Controller::AutoCompleteSearch
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
 
   def index
-    @subnets = Subnet.search_for(params[:search], :order => params[:order]).includes(:domains, :dhcp).paginate :page => params[:page]
+    @subnets = resource_base.search_for(params[:search], :order => params[:order]).includes(:domains, :dhcp).paginate :page => params[:page]
   end
 
   def new
@@ -19,11 +20,9 @@ class SubnetsController < ApplicationController
   end
 
   def edit
-    @subnet = Subnet.find(params[:id])
   end
 
   def update
-    @subnet = Subnet.find(params[:id])
     if @subnet.update_attributes(params[:subnet])
       process_success
     else
@@ -32,7 +31,6 @@ class SubnetsController < ApplicationController
   end
 
   def destroy
-    @subnet = Subnet.find(params[:id])
     if @subnet.destroy
       process_success
     else
@@ -46,7 +44,7 @@ class SubnetsController < ApplicationController
     organization = params[:organization_id].blank? ? nil : Organization.find(params[:organization_id])
     location = params[:location_id].blank? ? nil : Location.find(params[:location_id])
     Taxonomy.as_taxonomy organization, location do
-      not_found and return unless (subnet = Subnet.find(s))
+      not_found and return unless (subnet = Subnet.authorized(:view_subnets).find(s))
       if (ip = subnet.unused_ip(params[:host_mac]))
         render :json => {:ip => ip}
       else
@@ -55,7 +53,7 @@ class SubnetsController < ApplicationController
       end
     end
   rescue => e
-    logger.warn "Failed to query #{subnet} for free ip: #{e}"
+    logger.warn "Failed to query subnet #{s} for free ip: #{e}"
     head :status => 500
   end
 
